/*
 * jfrmTirarDado.java
 *
 * Created on 20 de enero de 2009, 17:41
 */
package Swing;

import java.awt.Color;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import src.Dado;
import src.Partida;

/**
 *
 * @author fco.dominguez
 * @author juan.alvarez
 */
public class jfrmTirarDado extends javax.swing.JFrame {

    private Partida partida;
    private int turno;
    private int[] valorTirada;
    private int mayor = 0;
    ArrayList<String> listaJug = new ArrayList<String>();

    /** Creates new form jfrmTirarDado */
    public jfrmTirarDado(Partida part) {
        initComponents();
        partida = part;
        turno = 0;
        valorTirada = new int[partida.getJugador().size()];
        jlbltxtInformacion.setText("");

        jlblNombreJugador.setOpaque(true);
        jlblNombreJugador.setBackground(dameColor(partida.getJugador().get(turno).getColor()));
        jlblNombreJugador.setText(partida.getJugador().get(turno).getNombreJugador());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jlbltxtTurnoDe = new javax.swing.JLabel();
        jlblNombreJugador = new javax.swing.JLabel();
        jlblResultadoDado = new javax.swing.JLabel();
        jbtnComenzar = new javax.swing.JButton();
        jbtnTirarDado = new javax.swing.JButton();
        jlbltxtInformacion = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jlstJugadores = new javax.swing.JList();

        setTitle("Tirar dados");
        setResizable(false);

        jlbltxtTurnoDe.setText("Turno de:");

        jlblNombreJugador.setFont(new java.awt.Font("Bitstream Vera Sans", 0, 24));
        jlblNombreJugador.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jlblNombreJugador.setText("Jugador");

        jlblResultadoDado.setFont(new java.awt.Font("Bitstream Vera Sans", 1, 48)); // NOI18N
        jlblResultadoDado.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jlblResultadoDado.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagenes/dado.png"))); // NOI18N

        jbtnComenzar.setText("Comenzar");
        jbtnComenzar.setEnabled(false);
        jbtnComenzar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnComenzarActionPerformed(evt);
            }
        });

        jbtnTirarDado.setText("Tirar dado");
        jbtnTirarDado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnTirarDadoActionPerformed(evt);
            }
        });

        jlbltxtInformacion.setForeground(new java.awt.Color(255, 0, 0));
        jlbltxtInformacion.setText("jLabel1");

        jScrollPane1.setViewportView(jlstJugadores);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jlblResultadoDado, javax.swing.GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jlbltxtTurnoDe)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jlblNombreJugador, javax.swing.GroupLayout.PREFERRED_SIZE, 149, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jbtnComenzar, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE)
                    .addComponent(jlbltxtInformacion)
                    .addComponent(jbtnTirarDado, javax.swing.GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jlbltxtTurnoDe)
                    .addComponent(jlblNombreJugador))
                .addGap(12, 12, 12)
                .addComponent(jlblResultadoDado)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 19, Short.MAX_VALUE)
                .addComponent(jbtnTirarDado)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jlbltxtInformacion)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jbtnComenzar)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jbtnTirarDadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnTirarDadoActionPerformed
// TODO add your handling code here:
    //el jugador tira el dado, de tipo "i", de inicial
    partida.getJugador().get(turno).setDadoComienzo(new Dado('i'));
    valorTirada[turno] = partida.getJugador().get(turno).getDadoComienzo().getValor();

    //mostramos el resultado
    jlblResultadoDado.setText("" + valorTirada[turno]);

    //comprobamos que no es un valor repetido
    boolean repetido = false;
    for (int i = 0; i < turno; i++) {
        if (valorTirada[turno] == valorTirada[i]) {
            repetido = true;
        }
    }
    //si no es un valor repetido
    if (!repetido) {


        listaJug.add(partida.getJugador().get(turno).getNombreJugador() + " (" + valorTirada[turno] +")");
        jlstJugadores.setListData(listaJug.toArray());

        turno++;
        jlbltxtInformacion.setText("");


        //si ya han tirado todos
        if (turno == partida.getJugador().size()) {
            jbtnTirarDado.setEnabled(false);
            jbtnComenzar.setEnabled(true);
        } else {
            jlblNombreJugador.setOpaque(true);
            jlblNombreJugador.setBackground(dameColor(partida.getJugador().get(turno).getColor()));
            jlblNombreJugador.setText(partida.getJugador().get(turno).getNombreJugador());

        }
    } else {
        jlbltxtInformacion.setText("Tire de nuevo");
    }

}//GEN-LAST:event_jbtnTirarDadoActionPerformed

    Color dameColor(int valor) {
        switch (valor) {
            case 0:
                return Color.red;
            case 1:
                return Color.cyan;
            case 2:
                return Color.green;
            case 3:
                return Color.yellow;
            case 4:
                return Color.pink;
            case 5:
                return Color.white;
        }
        return Color.black;
    }

private void jbtnComenzarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnComenzarActionPerformed
    try {
// TODO add your handling code here:
        partida.ordenarJug();
        partida.jugar();
    } catch (IOException ex) {
        Logger.getLogger(jfrmTirarDado.class.getName()).log(Level.SEVERE, null, ex);
    }

    jfrmAtacar ventanaAtaque = new jfrmAtacar(partida);
    jfrmGestionarCartas ventanaCartas = new jfrmGestionarCartas(partida);
    jfrmMoverTropas ventanaMover = new jfrmMoverTropas(partida);
    jfrmTablero tabJuego = new jfrmTablero(partida, ventanaAtaque, ventanaCartas, ventanaMover);


    partida.addObserver(tabJuego);
    partida.addObserver(ventanaAtaque);
    partida.addObserver(ventanaMover);
    partida.addObserver(ventanaCartas);

    //NewJFrame tabJuego = new NewJFrame(partida.getTablero(),partida.getJugador());
    tabJuego.setVisible(true);
    this.setVisible(false);

}//GEN-LAST:event_jbtnComenzarActionPerformed

    /**
    * @param args the command line arguments
    */
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton jbtnComenzar;
    private javax.swing.JButton jbtnTirarDado;
    private javax.swing.JLabel jlblNombreJugador;
    private javax.swing.JLabel jlblResultadoDado;
    private javax.swing.JLabel jlbltxtInformacion;
    private javax.swing.JLabel jlbltxtTurnoDe;
    private javax.swing.JList jlstJugadores;
    // End of variables declaration//GEN-END:variables

}
