package src;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 *
 * @author fco.dominguez
 * @author juan.alvarez
 */

public class Tablero{

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0504E04F-9C42-E4E3-EE54-94637D2DA1AE]
    // </editor-fold> 
    private ArrayList<Continente> continentes;//arrray que contiene todos los contientes creados

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.935068A6-0155-1EE3-D236-8397820DC7EF]
    // </editor-fold> 
    private ArrayList<Territorio> territorios;//array que contiene todos los territorios creados
    
    private ArrayList<CartaTerritorio> cartasTerritorios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.28DD8923-B3D2-0D0A-ED4B-EDC08AE42673]
    // </editor-fold> 
    public Tablero () {
        continentes = new ArrayList(6);
        territorios = new ArrayList<Territorio>(42);
        cartasTerritorios = new ArrayList<CartaTerritorio>(42);
        leerFichero();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CE164651-A4C0-741D-EE24-512A28F74AFA]
    // </editor-fold> 
    public ArrayList<Continente> getContinente () {
        return continentes;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A81B0EDD-4C8F-0386-6C9C-5A575593F608]
    // </editor-fold> 
    public void setContinente (ArrayList<Continente> val) {
        continentes = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9E96A54F-BBDB-8DA9-6F69-EFDC2A5CEA6D]
    // </editor-fold> 
    public ArrayList<Territorio> getTerritorio () {
        return territorios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CDFCE484-8B9D-E3A1-9D92-D312F8206FF9]
    // </editor-fold> 
    public void setTerritorio (ArrayList<Territorio> val) {
        territorios = val;
    }

    public ArrayList<CartaTerritorio> getCartasTerritorios() {
        return cartasTerritorios;
    }

    public void setCartasTerritorios(ArrayList<CartaTerritorio> cartasTerritorios) {
        this.cartasTerritorios = cartasTerritorios;
    }
    
    public void setCartasTerritorios(CartaTerritorio cartasTerritorios) {
        this.cartasTerritorios.add(cartasTerritorios);
    }

    //********************************** metodo cortesia de condadoconsulting *******************************************************
    public void leerFichero(){
        FileReader file = null;
        BufferedReader buffer = null;
        
//        continentes = new ArrayList(6);
//        territorios = new ArrayList<Territorio>(42);        
        
        int continenteActual = 0;
        int territorioActual = 0;
        
        try
        {            
            String nombreFichero = "./src/files/Tablero.doc";
            
            file = new FileReader(nombreFichero);
            buffer = new BufferedReader(file);
             
            String linea;            
            
            while ((linea=buffer.readLine()) != null)
            {
                if (linea.contains("<Continente>"))
                {                        
                    String nombreContinente = buffer.readLine();
                    int numtropas = Integer.parseInt(buffer.readLine());
                    Continente c = new Continente(nombreContinente.trim(), numtropas);
                    continentes.add(continenteActual,c);
                    continenteActual++;
                }
                else if (linea.contains("<Territorio>"))
                {              
                    //String id = buffer.readLine();                            
                    String nombreTerritorio = buffer.readLine();                    
                    Territorio t = new Territorio(nombreTerritorio.trim());
                    //t.setId(contadorIdTerritorio);
                    //t.setNumEjercitos(1);
                    //contadorIdTerritorio++;
                    territorios.add(territorioActual,t);
                    territorioActual++;
                    continentes.get(continenteActual-1).setTerritorio(t); 
                }
                else if(linea.contains("<Colindante>"))
                {                     
                    /*Localizamos el territorio origen dentro del array*/
                    String territorioOrigenNombre = buffer.readLine();
                    Territorio territorioOrigen = buscarTerritorio(territorioOrigenNombre);
                    if (territorioOrigen != null)
                    {                                      
                        /*Definnimos un delimitador*/
                        StringTokenizer st = new StringTokenizer(buffer.readLine(),":");
                        while (st.hasMoreTokens())
                        {
                            Territorio tAdyacente = buscarTerritorio(st.nextToken());
                            territorioOrigen.setTerritoriosAdy(tAdyacente);
                        }
                    }
                }
                else if(linea.contains("<CartaInfanteria>")){
                    //String carta = buffer.readLine();
                    Territorio terr = territorios.get(territorioActual-1);
                    CartaTerritorio ct = new CartaTerritorio(terr,1);
                    setCartasTerritorios(ct);
                }
                else if(linea.contains("<CartaCaballeria>")){
                    //String carta = buffer.readLine();
                    Territorio terr = territorios.get(0);//territorioActual-1);
                    CartaTerritorio ct = new CartaTerritorio(terr,5);
                    setCartasTerritorios(ct);
                }
                else if(linea.contains("<CartaArtilleria>")){
                    //String carta = buffer.readLine();
                    Territorio terr = territorios.get(territorioActual-1);
                    CartaTerritorio ct = new CartaTerritorio(terr,10);
                    setCartasTerritorios(ct);
                }
            }
            
            
            /*Intentamos cerrar el fichero*/
            try
            {
                file.close();        
            }
            catch (IOException error)
            {
                System.out.println(error.getMessage());
            }
                                
        }
        catch(Exception error){
            System.out.println(error.getMessage());
            //Exception e = new Exception("No se puede abrir el archivo para crear el Tablero");
        }                  
    }
    
    public Territorio buscarTerritorio(String nombre)
    {
        /*Recorremos el array buscando un territorio cuyo nombre sea el indicado*/
        //System.out.println("    " +nombre);
        for (int i=0; i<territorios.size(); i++)        
        {
            if (territorios.get(i).getNombreTerritorio().equals(nombre))
                return territorios.get(i);
        }                
        return null;
    }
    
}
